<?php
$WIKI_OPERATORS_FUNCTION['meta'] = true;
function wiki_operator_meta(&$context, $dom, $tree) {
    $meta_names = array();
    $pagename = $context['page']['name'];
    wiki_parse_parameters(
	$context, $tree, array('pagename' => &$pagename, 'values' => &$meta_names));
    $meta_name = array_shift($meta_names);
    if(empty($meta_name)) {
	dom_append_error($dom, l('&meta no meta data name'));
	return;
    }

    $page = page_read($pagename);
    $meta_value = default_value($page['meta']['wiki_' . $meta_name], '');

    dom_append_text($dom, $meta_value);

    wiki_convert_from_tokens($context, $dom, $tree->target);
}

$WIKI_OPERATORS_FUNCTION['metaedit'] = true;
function wiki_operator_metaedit(&$context, $dom, $tree) {
    global $main_pagename;

    $meta_names = array();
    $input_type = 'text';
    $options = 'true/false';
    $pagename = $context['page']['name'];
    wiki_parse_parameters(
	$context, $tree,
	array(
	    'pagename' => &$pagename,
	    'values' => &$meta_names,
	    'equalities' => array(
		'type' => &$input_type,
		'options' => &$options,
		),
	    )
	);
    $meta_name = array_shift($meta_names);
    if(empty($meta_name)) {
	dom_append_error($dom, l('&metaedit no meta data name'));
	return;
    }

    $page = page_read($pagename);
    $meta_value = default_value($page['meta']['wiki_' . $meta_name], '');
    
    wiki_convert_from_tokens($context, $dom, $tree->target);

    if($page['is_exists']) {
	$form = dom_append_page_form(
	    $page, $dom,
	    array('option' => 'wiki_metaedit',
		  'meta_name' => $meta_name,
		  'redirect' => url_make($main_pagename),
		  'action' => 'write'), 'metaedit');

	switch($input_type) {
	case 'select':
	    $option_elements = options_parse($options);
	    dom_append_selector($form, 'meta_value', $option_elements, $meta_value);
	    break;

	case 'text':
	default:
	    dom_append_child($form, 'input', 'metaedit_text',
			     array('type' => $input_type, 'name' => 'meta_value', 'value' => $meta_value));
	    break;
	}

	$input = dom_append_child($form, 'input', '',
				  array('type' => 'submit', 'value' => l('Change')));
    } else {
	$span = dom_append_child($dom, 'span', 'error');
	ld($span, '$pagename$ not found.', array('pagename' => dom_pagename($pagename)));
    }

    wiki_convert_from_tokens($context, $dom, $tree->target);
}

$OPTIONS['wiki_metaedit'] = array(
    'write' => 'wiki_option_metaedit_write',
    );

function wiki_option_metaedit_write(&$args, $dom) {
    $page = &target_page($args);

    if(empty($args['meta_name'])) {
	message_error(l('Invalid parameter.'));
	return false;
    }
    $meta_name = $args['meta_name'];
    $meta_value = default_value($args['meta_value'], '');
    
    $page['meta']['wiki_' . $meta_name] = $meta_value;

    $fp = page_open_contents($page);
    if(!page_write($page, $fp, $args['ticket'], $error)) {
	message_error(l('Page write failed.'));
    } else if(!empty($args['redirect'])) {
	header('Location: ' . $args['redirect']);
	exit(0);
    }
    
    return true;
}

?>
